
; CC5X Version 3.1I, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  13. Apr 2008  14:56  *************

	processor  16F88
	radix  DEC

INDF        EQU   0x00
PCL         EQU   0x02
FSR         EQU   0x04
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
PCLATH      EQU   0x0A
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
IRP         EQU   7
RCSTA       EQU   0x18
TXREG       EQU   0x19
RCREG       EQU   0x1A
TXSTA       EQU   0x98
SPBRG       EQU   0x99
ANSEL       EQU   0x9B
EEDATA      EQU   0x10C
EEADR       EQU   0x10D
EEDATH      EQU   0x10E
EEADRH      EQU   0x10F
TXIF        EQU   4
RCIF        EQU   5
RD          EQU   0
EEPGD       EQU   7
response    EQU   0x21
x_val       EQU   0x22
y_val       EQU   0x23
z_val       EQU   0x24
register_name EQU   0x25
in_byte     EQU   0x26
register_name_2 EQU   0x22
register_value EQU   0x23
device_address EQU   0x27
j           EQU   0x27
in_byte_2   EQU   0x28
out_byte    EQU   0x28
i           EQU   0x29
x           EQU   0x7F
y           EQU   0x7F
z           EQU   0x7F
x_2         EQU   0x2A
nate        EQU   0x35
counter     EQU   0x7F
x_3         EQU   0x35
nate_2      EQU   0x25
my_byte     EQU   0x26
i_2         EQU   0x28
k           EQU   0x29
m           EQU   0x2A
temp        EQU   0x2B
high_byte   EQU   0x2C
low_byte    EQU   0x2D
C1cnt       EQU   0x35
C2tmp       EQU   0x36
C3cnt       EQU   0x35
C4tmp       EQU   0x36
C5cnt       EQU   0x35
C6tmp       EQU   0x36
C7rem       EQU   0x38
ci          EQU   0x35

	GOTO main

  ; FILE C:\Global\Code\16F88\LIS302DL-Testing\LIS302DL-Tester.c
			;/*
			;    3-26-08
			;    Nathan Seidle
			;    nathan@sparkfun.com
			;    Copyright Spark Fun Electronics 2008
			;    
			;    Software I2C control
			;    PIC 16F88
			;    
			;    Reading and writing to LIS302DL
			;    
			;    This is a very small but powerful, configurable triple axis accelerometer.
			;    
			;    By default, the SparkFun LIS302DL breakout board is configured for SPI but
			;    can be easily modified to use I2C.
			;    
			;    At first look, the interface can be daunting, but once things are running,
			;    this is an impressive little sensor!
			;    
			;*/
			;#define Clock_8MHz
			;#define Baud_9600
			;
			;#include "c:\Global\Code\C\16F88.h"  // device dependent interrupt definitions
			;
			;#pragma origin 4
	ORG 0x0004
			;
			;#define STATUS_LED PORTB.3
			;
			;#define SCL     PORTB.7 //This is a clock into the LIS from the PIC
			;#define SDA     PORTB.6 //This is output/input to the LIS from the PIC
			;#define SDO     PORTB.4 //This is SDO and controls the LSB of the I2C slave address - should be pulled low
			;
			;#define WRITE_sda() TRISB = TRISB & 0b.1011.1111 //SDA must be output when writing
			;#define READ_sda()  TRISB = TRISB | 0b.0100.0000 //SDA must be input when reading - don't forget the resistor on SDA!!
			;
			;#define I2C_DELAY   10
			;
			;#define ACK     1
			;#define NO_ACK  0
			;
			;#define DEVICE_WRITE    0x38 //Default LIS302DL I2C address - write
			;#define DEVICE_READ     0x39 //Default LIS302DL I2C address - read
			;
			;void boot_up(void);
			;
			;uns8 read_register(uns8 register_name);
			;void write_register(uns8 register_name, uns8 register_value);
			;void LIS3LV02DQ_Test(void);
			;
			;void i2c_ack_polling(uns8 device_address);
			;void i2c_start(void);
			;void i2c_stop(void);
			;uns8 i2c_read_byte(void);
			;bit i2c_send_byte(uns8 out_byte);
			;
			;
			;void delay_ms(uns16 x);
			;void delay_us(uns16 x);
			;uns8 bin2Hex(char x);
			;void printf(const char *nate, int16 my_byte);
			;
			;void main(void)
			;{
_const1
	MOVWF ci
	MOVLW .0
	BSF   0x03,RP1
	MOVWF EEADRH
	BCF   0x03,RP1
	RRF   ci,W
	ANDLW .127
	ADDLW .35
	BSF   0x03,RP1
	MOVWF EEADR
	BTFSC 0x03,Carry
	INCF  EEADRH,1
	BSF   0x03,RP0
	BSF   0x18C,EEPGD
	BSF   0x18C,RD
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC ci,0
	GOTO  m001
	BSF   0x03,RP1
	MOVF  EEDATA,W
	ANDLW .127
	BCF   0x03,RP1
	RETURN
m001	BSF   0x03,RP1
	RLF   EEDATA,W
	RLF   EEDATH,W
	BCF   0x03,RP1
	RETURN
	DW    0x260A
	DW    0x29C9
	DW    0x1833
	DW    0x2232
	DW    0x104C
	DW    0x32D4
	DW    0x3A73
	DW    0x3769
	DW    0x1D67
	DW    0x50A
	DW    0xD
	DW    0x68A
	DW    0x3457
	DW    0x106F
	DW    0x36E1
	DW    0x24A0
	DW    0x1420
	DW    0x3473
	DW    0x3AEF
	DW    0x326C
	DW    0x3120
	DW    0x1065
	DW    0x3C30
	DW    0x2133
	DW    0x1D29
	DW    0x12A0
	DW    0x568
	DW    0xD
	DW    0x1EF8
	DW    0x3225
	DW    0x20
	DW    0x1EF9
	DW    0x3225
	DW    0x20
	DW    0x1EFA
	DW    0x3225
	DW    0x20
	DW    0xA
main
			;    uns8 choice;
			;    
			;    boot_up(); //Init ports and settings
	BSF   0x03,RP0
	BCF   0x03,RP1
	CALL  boot_up
			;        
			;    STATUS_LED = 0;
	BCF   PORTB,3
			;
			;    printf("\nLIS302DL Testing:\n\n\r", 0);
	CLRF  nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;
			;    uns8 response;
			;
			;    response = read_register(0x0F); //Who am I
	MOVLW .15
	CALL  read_register
	MOVWF response
			;    printf("\n\rWho am I (should be 0x3B): %h\n\r", response);
	MOVLW .22
	MOVWF nate_2
	MOVF  response,W
	MOVWF my_byte
	CLRF  my_byte+1
	CALL  printf
			;
			;    write_register(0x20, 0b.0100.0111); //Power on device, enable all axis, and turn off self test - CTRL_REG1
	MOVLW .32
	MOVWF register_name_2
	MOVLW .71
	CALL  write_register
			;
			;    while(1)
			;    {
			;        STATUS_LED ^= 1;
m002	MOVLW .8
	XORWF PORTB,1
			;
			;        /*if(RCIF)
			;        {
			;            choice = RCREG;
			;            if(choice == 'x') break;
			;        }*/
			;        
			;        int8 x_val, y_val, z_val;
			;        x_val.low8 = read_register(0x29); //Read outx_l
	MOVLW .41
	CALL  read_register
	MOVWF x_val
			;        printf("x=%d ", x_val);
	MOVLW .56
	MOVWF nate_2
	MOVF  x_val,W
	MOVWF my_byte
	CLRF  my_byte+1
	BTFSC my_byte,7
	DECF  my_byte+1,1
	CALL  printf
			;
			;        y_val.low8 = read_register(0x2B); //Read outy_l
	MOVLW .43
	CALL  read_register
	MOVWF y_val
			;        printf("y=%d ", y_val);
	MOVLW .62
	MOVWF nate_2
	MOVF  y_val,W
	MOVWF my_byte
	CLRF  my_byte+1
	BTFSC my_byte,7
	DECF  my_byte+1,1
	CALL  printf
			;
			;        z_val.low8 = read_register(0x2D); //Read outz_l
	MOVLW .45
	CALL  read_register
	MOVWF z_val
			;        printf("z=%d ", z_val);
	MOVLW .68
	MOVWF nate_2
	MOVF  z_val,W
	MOVWF my_byte
	CLRF  my_byte+1
	BTFSC my_byte,7
	DECF  my_byte+1,1
	CALL  printf
			;
			;        printf("\n", 0);
	MOVLW .74
	MOVWF nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;    }
	GOTO  m002
			;
			;    while(1);
m003	GOTO  m003
			;
			;}//End Main
			;
			;void boot_up(void)
			;{
boot_up
			;    //OSCCON = 0b.0111.0000; //Setup internal oscillator for 8MHz
			;    //while(OSCCON.2 == 0); //Wait for frequency to stabilize
			;
			;    //Setup Ports
			;    ANSEL = 0b.0000.0000; //Turn off A/D
	CLRF  ANSEL
			;
			;    PORTA = 0b.0000.0000;
	BCF   0x03,RP0
	CLRF  PORTA
			;    TRISA = 0b.0000.0000;  //0 = Output, 1 = Input
	BSF   0x03,RP0
	CLRF  TRISA
			;
			;    //SCL     PORTB.7 //This is a clock into the LIS from the PIC
			;    //SDA     PORTB.6 //This is input/output
			;    //SDO     PORTB.4 //This is output from PIC, low
			;    //INT2    PORTB.1 //This is interrupt, not used, read as input and leave floating
			;    
			;    //Output PB7, PB6, PB4 - Input PB1
			;    PORTB = 0b.1100.0000;
	MOVLW .192
	BCF   0x03,RP0
	MOVWF PORTB
			;    TRISB = 0b.0000.0110;   //0 = Output, 1 = Input RX on RB2
	MOVLW .6
	BSF   0x03,RP0
	MOVWF TRISB
			;
			;    //OPREG = 0b.1111.1111; //Enable pull-ups
			;
			;    //Setup the hardware UART module
			;    //=============================================================
			;    SPBRG = 51; //8MHz for 9600 inital communication baud rate
	MOVLW .51
	MOVWF SPBRG
			;    //SPBRG = 129; //20MHz for 9600 inital communication baud rate
			;
			;    TXSTA = 0b.0010.0100; //8-bit asych mode, high speed uart enabled
	MOVLW .36
	MOVWF TXSTA
			;    RCSTA = 0b.1001.0000; //Serial port enable, 8-bit asych continous receive mode
	MOVLW .144
	BCF   0x03,RP0
	MOVWF RCSTA
			;    //=============================================================
			;}
	RETURN
			;
			;//Reads a register from LIS
			;uns8 read_register(uns8 register_name)
			;{
read_register
	MOVWF register_name
			;    uns8 in_byte;
			;    
			;    i2c_ack_polling(DEVICE_WRITE);
	MOVLW .56
	CALL  i2c_ack_polling
			;
			;    i2c_start();
	CALL  i2c_start
			;    i2c_send_byte(DEVICE_WRITE); 
	MOVLW .56
	CALL  i2c_send_byte
			;    i2c_send_byte(register_name); //Write register address   
	MOVF  register_name,W
	CALL  i2c_send_byte
			;    //i2c_stop();
			;
			;    i2c_start(); //Repeat start (SR)
	CALL  i2c_start
			;    i2c_send_byte(DEVICE_READ); //Now ask the IC to report on the last command
	MOVLW .57
	CALL  i2c_send_byte
			;    in_byte = i2c_read_byte();
	CALL  i2c_read_byte
	MOVWF in_byte
			;    i2c_stop();
	CALL  i2c_stop
			;        
			;    return(in_byte);
	MOVF  in_byte,W
	RETURN
			;}
			;
			;//Write to a register in LIS
			;void write_register(uns8 register_name, uns8 register_value)
			;{
write_register
	MOVWF register_value
			;    i2c_ack_polling(DEVICE_WRITE);
	MOVLW .56
	CALL  i2c_ack_polling
			;
			;    i2c_start();
	CALL  i2c_start
			;    i2c_send_byte(DEVICE_WRITE); 
	MOVLW .56
	CALL  i2c_send_byte
			;    i2c_send_byte(register_name); //Write register address
	MOVF  register_name_2,W
	CALL  i2c_send_byte
			;    i2c_send_byte(register_value); //Write data
	MOVF  register_value,W
	CALL  i2c_send_byte
			;    i2c_stop();
	GOTO  i2c_stop
			;
			;    //Return nothing
			;}
			;
			;//Software I2C Routines
			;//====================================
			;void i2c_ack_polling(uns8 device_address)
			;{
i2c_ack_polling
	MOVWF device_address
			;    while(1)
			;    {
			;        i2c_start();
m004	CALL  i2c_start
			;        if (i2c_send_byte(device_address) == ACK) break;
	MOVF  device_address,W
	CALL  i2c_send_byte
	BTFSS 0x03,Carry
	GOTO  m004
	GOTO  i2c_stop
			;    }
			;    i2c_stop();
			;}
			;
			;void i2c_start(void)
			;{
i2c_start
			;    WRITE_sda();
	BSF   0x03,RP0
	BCF   TRISB,6
			;    SDA = 1;
	BCF   0x03,RP0
	BSF   PORTB,6
			;    delay_us(I2C_DELAY);
	MOVLW .10
	MOVWF x_2
	CLRF  x_2+1
	CALL  delay_us
			;
			;    SCL = 1;
	BSF   PORTB,7
			;    delay_us(I2C_DELAY);
	MOVLW .10
	MOVWF x_2
	CLRF  x_2+1
	CALL  delay_us
			;
			;    SDA = 0;
	BCF   PORTB,6
			;    delay_us(I2C_DELAY);
	MOVLW .10
	MOVWF x_2
	CLRF  x_2+1
	GOTO  delay_us
			;}
			;
			;//The I2C Clock has a minimum of 2us high time and 2us low time
			;void i2c_stop(void)
			;{
i2c_stop
			;    SCL = 0;
	BCF   PORTB,7
			;    delay_us(I2C_DELAY);
	MOVLW .10
	MOVWF x_2
	CLRF  x_2+1
	CALL  delay_us
			;
			;    WRITE_sda();
	BSF   0x03,RP0
	BCF   TRISB,6
			;
			;    SDA = 0;
	BCF   0x03,RP0
	BCF   PORTB,6
			;    delay_us(I2C_DELAY);
	MOVLW .10
	MOVWF x_2
	CLRF  x_2+1
	CALL  delay_us
			;
			;    SCL = 1;
	BSF   PORTB,7
			;    delay_us(I2C_DELAY);
	MOVLW .10
	MOVWF x_2
	CLRF  x_2+1
	CALL  delay_us
			;
			;    SDA = 1;
	BSF   PORTB,6
			;    delay_us(I2C_DELAY);
	MOVLW .10
	MOVWF x_2
	CLRF  x_2+1
	GOTO  delay_us
			;}
			;
			;//The I2C Clock has a minimum of 2us high time and 2us low time
			;//8MHz = 0.5us per instruction
			;uns8 i2c_read_byte(void)
			;{
i2c_read_byte
			;    int j, in_byte;
			;
			;    SCL = 0;
	BCF   PORTB,7
			;
			;    READ_sda();
	BSF   0x03,RP0
	BSF   TRISB,6
			;
			;    for(j = 0 ; j < 8 ; j++)
	BCF   0x03,RP0
	CLRF  j
m005	BTFSC j,7
	GOTO  m006
	MOVLW .8
	SUBWF j,W
	BTFSC 0x03,Carry
	GOTO  m007
			;    {
			;        SCL = 0;
m006	BCF   PORTB,7
			;        delay_us(I2C_DELAY);
	MOVLW .10
	MOVWF x_2
	CLRF  x_2+1
	CALL  delay_us
			;
			;        SCL = 1;
	BSF   PORTB,7
			;        delay_us(I2C_DELAY);
	MOVLW .10
	MOVWF x_2
	CLRF  x_2+1
	CALL  delay_us
			;
			;        in_byte = rl(in_byte);
	RLF   in_byte_2,1
			;        in_byte.0 = SDA;
	BCF   in_byte_2,0
	BTFSC PORTB,6
	BSF   in_byte_2,0
			;    }
	INCF  j,1
	GOTO  m005
			;
			;    //Send 9th bit acknowledge
			;/*
			;    For the LIS, single byte reads, there is NMAK or no master acknowledge
			;    SCL = 0;
			;    WRITE_sda();
			;    SDA = 0;
			;    delay_us(I2C_DELAY);
			;    SCL = 1;
			;
			;    delay_us(I2C_DELAY);
			;    SCL = 0;
			;
			;    delay_us(I2C_DELAY);
			;    SDA = 1;
			;    while(1);
			;*/
			;    return(in_byte);
m007	MOVF  in_byte_2,W
	RETURN
			;}
			;
			;//The I2C Clock has a minimum of 2us high time and 2us low time
			;//8MHz = 500ns per instruction
			;bit i2c_send_byte(uns8 out_byte)
			;{
i2c_send_byte
	MOVWF out_byte
			;    uns8 i;
			;
			;    WRITE_sda();
	BSF   0x03,RP0
	BCF   TRISB,6
			;
			;    for(i = 0 ; i < 8 ; i++)
	BCF   0x03,RP0
	CLRF  i
m008	MOVLW .8
	SUBWF i,W
	BTFSC 0x03,Carry
	GOTO  m009
			;    {
			;        SCL = 0;
	BCF   PORTB,7
			;        delay_us(I2C_DELAY);
	MOVLW .10
	MOVWF x_2
	CLRF  x_2+1
	CALL  delay_us
			;
			;        out_byte = rl(out_byte);
	RLF   out_byte,1
			;        SDA = Carry;
	BTFSS 0x03,Carry
	BCF   PORTB,6
	BTFSC 0x03,Carry
	BSF   PORTB,6
			;        delay_us(5);
	MOVLW .5
	MOVWF x_2
	CLRF  x_2+1
	CALL  delay_us
			;
			;        SCL = 1;
	BSF   PORTB,7
			;        delay_us(I2C_DELAY);
	MOVLW .10
	MOVWF x_2
	CLRF  x_2+1
	CALL  delay_us
			;    }
	INCF  i,1
	GOTO  m008
			;
			;    //Read ack
			;    SCL = 0;
m009	BCF   PORTB,7
			;    delay_us(I2C_DELAY);
	MOVLW .10
	MOVWF x_2
	CLRF  x_2+1
	CALL  delay_us
			;
			;    READ_sda();
	BSF   0x03,RP0
	BSF   TRISB,6
			;
			;    SCL = 1;
	BCF   0x03,RP0
	BSF   PORTB,7
			;    delay_us(I2C_DELAY);
	MOVLW .10
	MOVWF x_2
	CLRF  x_2+1
	CALL  delay_us
			;
			;    //Wait for IC to acknowledge
			;    for(i = 0 ; i < 255 ; i++)
	CLRF  i
m010	INCF  i,W
	BTFSC 0x03,Zero_
	GOTO  m011
			;        if(SDA == 0) break;
	BTFSS PORTB,6
	GOTO  m011
			;
			;    SCL = 0;
	INCF  i,1
	GOTO  m010
m011	BCF   PORTB,7
			;    delay_us(I2C_DELAY);
	MOVLW .10
	MOVWF x_2
	CLRF  x_2+1
	CALL  delay_us
			;
			;    if (i == 255) return(NO_ACK);
	INCFSZ i,W
	GOTO  m012
	BCF   0x03,Carry
	RETURN
			;    
			;    return(ACK);
m012	BSF   0x03,Carry
	RETURN
			;}
			;//====================================
			;
			;//General short delay
			;void delay_ms(uns16 x)
			;{
delay_ms
			;    //Clocks out at 1006us per 1ms
			;    uns8 y, z;
			;    for ( ; x > 0 ; x--)
m013	MOVF  x,W
	IORWF x+1,W
	BTFSC 0x03,Zero_
	GOTO  m018
			;        for ( y = 0 ; y < 4 ; y++)
	CLRF  y
m014	MOVLW .4
	SUBWF y,W
	BTFSC 0x03,Carry
	GOTO  m017
			;            for ( z = 0 ; z < 69 ; z++);
	CLRF  z
m015	MOVLW .69
	SUBWF z,W
	BTFSC 0x03,Carry
	GOTO  m016
	INCF  z,1
	GOTO  m015
m016	INCF  y,1
	GOTO  m014
m017	DECF  x,1
	INCF  x,W
	BTFSC 0x03,Zero_
	DECF  x+1,1
	GOTO  m013
			;}
m018	RETURN
			;
			;//Really short delay
			;void delay_us(uns16 x)
			;{
delay_us
			;    //Calling with 1us returns 7.5us
			;    //Calling with 10us returns 48
			;    //Calling with 1000us returns 4.5ms
			;    while(--x); 
m019	DECF  x_2,1
	INCF  x_2,W
	BTFSC 0x03,Zero_
	DECF  x_2+1,1
	MOVF  x_2,W
	IORWF x_2+1,W
	BTFSS 0x03,Zero_
	GOTO  m019
			;}
	RETURN
			;
			;//Sends nate to the Transmit Register
			;void putc(uns8 nate)
			;{
putc
	MOVWF nate
			;    while(TXIF == 0);
m020	BTFSS 0x0C,TXIF
	GOTO  m020
			;    TXREG = nate;
	MOVF  nate,W
	MOVWF TXREG
			;}
	RETURN
			;
			;uns8 getc(void)
			;{
getc
			;    while(RCIF == 0);
	BCF   0x03,RP0
	BCF   0x03,RP1
m021	BTFSS 0x0C,RCIF
	GOTO  m021
			;    return (RCREG);
	MOVF  RCREG,W
	RETURN
			;}    
			;
			;uns8 scanc(void)
			;{
scanc
			;    uns16 counter = 0;
	CLRF  counter
	CLRF  counter+1
			;    
			;    //CREN = 0;
			;    //CREN = 1;
			;    
			;    RCIF = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x0C,RCIF
			;    while(RCIF == 0)
m022	BTFSC 0x0C,RCIF
	GOTO  m023
			;    {
			;        counter++;
	INCF  counter,1
	BTFSC 0x03,Zero_
	INCF  counter+1,1
			;        if(counter == 1000) return 0;
	MOVF  counter,W
	XORLW .232
	BTFSS 0x03,Zero_
	GOTO  m022
	MOVF  counter+1,W
	XORLW .3
	BTFSS 0x03,Zero_
	GOTO  m022
	RETLW .0
			;    }
			;    
			;    return (RCREG);
m023	MOVF  RCREG,W
	RETURN
			;}   
			;
			;//Returns ASCII Decimal and Hex values
			;uns8 bin2Hex(char x)
			;{
bin2Hex
	MOVWF x_3
			;   skip(x);
	MOVLW .1
	MOVWF PCLATH
	MOVF  x_3,W
	ADDWF PCL,1
			;   #pragma return[16] = "0123456789ABCDEF"
	RETLW .48
	RETLW .49
	RETLW .50
	RETLW .51
	RETLW .52
	RETLW .53
	RETLW .54
	RETLW .55
	RETLW .56
	RETLW .57
	RETLW .65
	RETLW .66
	RETLW .67
	RETLW .68
	RETLW .69
	RETLW .70
			;}
			;
			;//Prints a string including variables
			;void printf(const char *nate, int16 my_byte)
			;{
printf
			;    uns8 i, k, m, temp;
			;    uns8 high_byte = 0, low_byte = 0;
	CLRF  high_byte
	CLRF  low_byte
			;    uns8 y, z;
			;    
			;    uns8 decimal_output[5];
			;    
			;    for(i = 0 ; ; i++)
	CLRF  i_2
			;    {
			;        k = nate[i];
m024	MOVF  i_2,W
	ADDWF nate_2,W
	CALL  _const1
	MOVWF k
			;
			;        if (k == '\0') 
	MOVF  k,1
	BTFSC 0x03,Zero_
			;            break;
	GOTO  m050
			;
			;        else if (k == '%') //Print var
	XORLW .37
	BTFSS 0x03,Zero_
	GOTO  m048
			;        {
			;            i++;
	INCF  i_2,1
			;            k = nate[i];
	MOVF  i_2,W
	ADDWF nate_2,W
	CALL  _const1
	MOVWF k
			;
			;            if (k == '\0') 
	MOVF  k,1
	BTFSC 0x03,Zero_
			;                break;
	GOTO  m050
			;            else if (k == '\\') //Print special characters
	XORLW .92
	BTFSS 0x03,Zero_
	GOTO  m025
			;            {
			;                i++;
	INCF  i_2,1
			;                k = nate[i];
	MOVF  i_2,W
	ADDWF nate_2,W
	CALL  _const1
	MOVWF k
			;                
			;                putc(k);
	CALL  putc
			;            } //End Special Characters
			;            else if (k == 'b') //Print Binary
	GOTO  m049
m025	MOVF  k,W
	XORLW .98
	BTFSS 0x03,Zero_
	GOTO  m030
			;            {
			;                for( m = 0 ; m < 8 ; m++ )
	CLRF  m
m026	MOVLW .8
	SUBWF m,W
	BTFSC 0x03,Carry
	GOTO  m049
			;                {
			;                    if (my_byte.7 == 1) putc('1');
	BTFSS my_byte,7
	GOTO  m027
	MOVLW .49
	CALL  putc
			;                    if (my_byte.7 == 0) putc('0');
m027	BTFSC my_byte,7
	GOTO  m028
	MOVLW .48
	CALL  putc
			;                    if (m == 3) putc(' ');
m028	MOVF  m,W
	XORLW .3
	BTFSS 0x03,Zero_
	GOTO  m029
	MOVLW .32
	CALL  putc
			;                    
			;                    my_byte = my_byte << 1;
m029	BCF   0x03,Carry
	RLF   my_byte,1
	RLF   my_byte+1,1
			;                }
	INCF  m,1
	GOTO  m026
			;            } //End Binary               
			;            else if (k == 'd') //Print Decimal
m030	MOVF  k,W
	XORLW .100
	BTFSS 0x03,Zero_
	GOTO  m044
			;            {
			;                //Print negative sign and take 2's compliment
			;                
			;                if(my_byte < 0)
	BTFSS my_byte+1,7
	GOTO  m033
			;                {
			;                    putc('-');
	MOVLW .45
	CALL  putc
			;                    my_byte *= -1;
	MOVF  my_byte,W
	MOVWF C2tmp
	MOVF  my_byte+1,W
	MOVWF C2tmp+1
	MOVLW .16
	MOVWF C1cnt
m031	BCF   0x03,Carry
	RLF   my_byte,1
	RLF   my_byte+1,1
	RLF   C2tmp,1
	RLF   C2tmp+1,1
	BTFSS 0x03,Carry
	GOTO  m032
	DECF  my_byte+1,1
	DECF  my_byte,1
	INCFSZ my_byte,W
	INCF  my_byte+1,1
m032	DECFSZ C1cnt,1
	GOTO  m031
			;                }
			;                
			;                if (my_byte == 0)
m033	MOVF  my_byte,W
	IORWF my_byte+1,W
	BTFSS 0x03,Zero_
	GOTO  m034
			;                    putc('0');
	MOVLW .48
	CALL  putc
			;                else
	GOTO  m049
			;                {
			;                    //Divide number by a series of 10s
			;                    for(m = 4 ; my_byte > 0 ; m--)
m034	MOVLW .4
	MOVWF m
m035	BTFSC my_byte+1,7
	GOTO  m042
	MOVF  my_byte,W
	IORWF my_byte+1,W
	BTFSC 0x03,Zero_
	GOTO  m042
			;                    {
			;                        temp = my_byte % (uns16)10;
	MOVF  my_byte,W
	MOVWF C4tmp
	MOVF  my_byte+1,W
	MOVWF C4tmp+1
	CLRF  temp
	MOVLW .16
	MOVWF C3cnt
m036	RLF   C4tmp,1
	RLF   C4tmp+1,1
	RLF   temp,1
	BTFSC 0x03,Carry
	GOTO  m037
	MOVLW .10
	SUBWF temp,W
	BTFSS 0x03,Carry
	GOTO  m038
m037	MOVLW .10
	SUBWF temp,1
m038	DECFSZ C3cnt,1
	GOTO  m036
			;                        decimal_output[m] = temp;
	MOVLW .48
	ADDWF m,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  temp,W
	MOVWF INDF
			;                        my_byte = my_byte / (uns16)10;               
	MOVF  my_byte,W
	MOVWF C6tmp
	MOVF  my_byte+1,W
	MOVWF C6tmp+1
	CLRF  C7rem
	MOVLW .16
	MOVWF C5cnt
m039	RLF   C6tmp,1
	RLF   C6tmp+1,1
	RLF   C7rem,1
	BTFSC 0x03,Carry
	GOTO  m040
	MOVLW .10
	SUBWF C7rem,W
	BTFSS 0x03,Carry
	GOTO  m041
m040	MOVLW .10
	SUBWF C7rem,1
	BSF   0x03,Carry
m041	RLF   my_byte,1
	RLF   my_byte+1,1
	DECFSZ C5cnt,1
	GOTO  m039
			;                    }
	DECF  m,1
	GOTO  m035
			;                
			;                    for(m++ ; m < 5 ; m++)
m042	INCF  m,1
m043	MOVLW .5
	SUBWF m,W
	BTFSC 0x03,Carry
	GOTO  m049
			;                        putc(bin2Hex(decimal_output[m]));
	MOVLW .48
	ADDWF m,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  INDF,W
	CALL  bin2Hex
	CALL  putc
	INCF  m,1
	GOTO  m043
			;                }
			;    
			;            } //End Decimal
			;            else if (k == 'h') //Print Hex
m044	MOVF  k,W
	XORLW .104
	BTFSS 0x03,Zero_
	GOTO  m046
			;            {
			;                //New trick 3-15-04
			;                putc('0');
	MOVLW .48
	CALL  putc
			;                putc('x');
	MOVLW .120
	CALL  putc
			;                
			;                if(my_byte > 0x00FF)
	BTFSC my_byte+1,7
	GOTO  m045
	MOVF  my_byte+1,1
	BTFSC 0x03,Zero_
	GOTO  m045
			;                {
			;                    putc(bin2Hex(my_byte.high8 >> 4));
	SWAPF my_byte+1,W
	ANDLW .15
	CALL  bin2Hex
	CALL  putc
			;                    putc(bin2Hex(my_byte.high8 & 0b.0000.1111));
	MOVLW .15
	ANDWF my_byte+1,W
	CALL  bin2Hex
	CALL  putc
			;                }
			;
			;                putc(bin2Hex(my_byte.low8 >> 4));
m045	SWAPF my_byte,W
	ANDLW .15
	CALL  bin2Hex
	CALL  putc
			;                putc(bin2Hex(my_byte.low8 & 0b.0000.1111));
	MOVLW .15
	ANDWF my_byte,W
	CALL  bin2Hex
	CALL  putc
			;
			;                /*high_byte.3 = my_byte.7;
			;                high_byte.2 = my_byte.6;
			;                high_byte.1 = my_byte.5;
			;                high_byte.0 = my_byte.4;
			;            
			;                low_byte.3 = my_byte.3;
			;                low_byte.2 = my_byte.2;
			;                low_byte.1 = my_byte.1;
			;                low_byte.0 = my_byte.0;
			;        
			;                putc('0');
			;                putc('x');
			;            
			;                putc(bin2Hex(high_byte));
			;                putc(bin2Hex(low_byte));*/
			;            } //End Hex
			;            else if (k == 'f') //Print Float
	GOTO  m049
m046	MOVF  k,W
	XORLW .102
	BTFSS 0x03,Zero_
	GOTO  m047
			;            {
			;                putc('!');
	MOVLW .33
	CALL  putc
			;            } //End Float
			;            else if (k == 'u') //Print Direct Character
	GOTO  m049
m047	MOVF  k,W
	XORLW .117
	BTFSS 0x03,Zero_
	GOTO  m049
			;            {
			;                //All ascii characters below 20 are special and screwy characters
			;                //if(my_byte > 20) 
			;                    putc(my_byte);
	MOVF  my_byte,W
	CALL  putc
			;            } //End Direct
			;                        
			;        } //End Special Chars           
			;
			;        else
	GOTO  m049
			;            putc(k);
m048	MOVF  k,W
	CALL  putc
			;    }    
m049	INCF  i_2,1
	GOTO  m024
m050	RETURN

	END


; *** KEY INFO ***

; 0x00AE P0   19 word(s)  0 % : boot_up
; 0x00C1 P0   16 word(s)  0 % : read_register
; 0x00D1 P0   11 word(s)  0 % : write_register
; 0x00DC P0    7 word(s)  0 % : i2c_ack_polling
; 0x00E3 P0   18 word(s)  0 % : i2c_start
; 0x00F5 P0   23 word(s)  1 % : i2c_stop
; 0x010C P0   29 word(s)  1 % : i2c_read_byte
; 0x0129 P0   62 word(s)  3 % : i2c_send_byte
; 0x0167 P0   24 word(s)  1 % : delay_ms
; 0x017F P0    9 word(s)  0 % : delay_us
; 0x01A9 P0   21 word(s)  1 % : bin2Hex
; 0x01BE P0  215 word(s) 10 % : printf
; 0x006F P0   63 word(s)  3 % : main
; 0x0188 P0    6 word(s)  0 % : putc
; 0x018E P0    6 word(s)  0 % : getc
; 0x0194 P0   21 word(s)  1 % : scanc
; 0x0004 P0   69 word(s)  3 % : _const1

; RAM usage: 26 bytes (26 local), 342 bytes free
; Maximum call level: 4
;  Codepage 0 has  658 word(s) :  32 %
;  Codepage 1 has    0 word(s) :   0 %
; Total of 620 code words (15 %)
